module.exports = function (RED) {
  'use strict';
  
  var MilkCocoa = require('milkcocoa');

  function MilkcocaGetNode (n) {
    RED.nodes.createNode(this, n);
    this.milkcocoa = n.milkcocoa;
    this.dataStore = n.dataStore;
    this.appId = n.appId;
    this.apiKey = n.apiKey;
    this.apiSecret = n.apiSecret;
    var node = this;
    var milkcocoa;
      
    if (this.apiKey && this.apiSecret) {
      milkcocoa = MilkCocoa.connectWithApiKey(this.appId + '.mlkcca.com', this.apiKey, this.apiSecret);
    } else {
      milkcocoa = new MilkCocoa(this.appId + '.mlkcca.com');
    }
    var ds = milkcocoa.dataStore(node.dataStore);

    node.on("input", function(msg) {
      ds.get(msg.key, function(err, data) {
        if (err) {
          node.status({fill:"red",shape:"ring",text:"error"});
          node.error("failed: " + err.toString() ,msg);
          return;
        } else {
          node.status({});
        }
        msg.payload = data;
        node.send(msg);
      });
    });
  }

  RED.nodes.registerType("milkcocoa-get", MilkcocaGetNode);

}